//Car.h
#include <UCMotor.h>

//設置3號馬達為左輪，4號馬達為右輪
static UC_DCMotor leftMotor(3,MOTOR34_64KHZ);
static UC_DCMotor rightMotor(4,MOTOR34_64KHZ);

//以指定速度轉動馬達
void run(uint8_t mode,int speed){
  //設置轉動模式
  leftMotor.run(mode);
  rightMotor.run(mode);
  //設置轉動速度
  leftMotor.setSpeed(speed);
  rightMotor.setSpeed(speed);
}
//以指定速度轉動馬達指定時間(毫秒)後停止
void run(uint8_t mode,int speed,unsigned long time){
  run(mode,speed);
  delay(time);
  run(STOP,0);
}

//沒有參數的版本

//車子前進(不停止)
void car_forward (){ run( FORWARD,200); }
//車子後退(不停止)
void car_backward(){ run(BACKWARD,200); }
//車子原地左轉(不停止)
void car_left    (){ run(    LEFT,200); }
//車子原地右轉(不停止)
void car_right   (){ run(   RIGHT,200); }
//車子停止
void car_stop    (){ run(    STOP,  0); }

//一個參數的版本

//車子以指定速度前進(不停止)
void car_forward (int speed){ run( FORWARD,speed); }
//車子以指定速度後退(不停止)
void car_backward(int speed){ run(BACKWARD,speed); }
//車子以指定速度原地左轉(不停止)
void car_left    (int speed){ run(    LEFT,speed); }
//車子以指定速度原地右轉(不停止)
void car_right   (int speed){ run(   RIGHT,speed); }
//車子停止
void car_stop    (int speed){ run(    STOP,speed); }

//兩個參數的版本

//車子以指定速度前進，持續指定時間(毫秒)後停止
void car_forward (int speed,unsigned long time){ run( FORWARD,speed,time); }
//車子以指定速度後退，持續指定時間(毫秒)後停止
void car_backward(int speed,unsigned long time){ run(BACKWARD,speed,time); }
//車子以指定速度原地左轉，持續指定時間(毫秒)後停止
void car_left    (int speed,unsigned long time){ run(    LEFT,speed,time); }
//車子以指定速度原地右轉，持續指定時間(毫秒)後停止
void car_right   (int speed,unsigned long time){ run(   RIGHT,speed,time); }
//車子持續停止指定時間
void car_stop    (int speed,unsigned long time){ run(    STOP,speed,time); }
