//Ultrasonic.h
#include <Servo.h>

//超音波感測器的轉向馬達
static Servo neckMotor;
static uint8_t servo_pin=10;
//超音波感測器的連接腳位
static uint8_t trig_pin=A2;
static uint8_t echo_pin=A3;

void setupUltrasonic(){
	//設置超音波感測器的連接腳位
	//trig為輸出,echo為輸入
	pinMode(trig_pin,OUTPUT);
	pinMode(echo_pin,INPUT);
	
	//將超音波感測器的轉向正面(90度)
	neckMotor.attach(servo_pin);
	neckMotor.write(90);
	delay(2000);
	neckMotor.detach();
	delay(100);
}
//轉動超音波感測器到指定角度(0~180)
//注意轉動需要一些時間
void rotateNeck(int angle){
	neckMotor.attach(servo_pin);
	neckMotor.write(angle);
	delay(500);
	neckMotor.detach();
	delay(100);
}
//取得超音波來回的時間(微秒)
long getTiming(){
	digitalWrite(trig_pin, LOW);
	delayMicroseconds(2);
	digitalWrite(trig_pin, HIGH);
	delayMicroseconds(10);
	digitalWrite(trig_pin, LOW);
	return pulseIn(echo_pin, HIGH);
}
//將超音波來回的時間換算為距離(公分)
float toCM(long timing){
	return timing / 58.8;
}
