//Bluetooth.h

void setupBluetooth(){
	//設定藍芽連線速率為115200 baud 
	Serial.begin(115200);
}

int bytesAvailableToReceive(){
	//取得目前可以接收的位元組數
	return Serial.available();
}


//發送1位元組長的有號數
void sendSigned1ByteNumber  (char num){
	Serial.write(num);
}
//發送2位元組長的有號數
void sendSigned2ByteNumber  (int num){
	Serial.write(num & 255);
	Serial.write((num >> 8)  & 255);
}
//發送4位元組長的有號數
void sendSigned4ByteNumber  (long num){
	Serial.write(num & 255);
	Serial.write((num >> 8) & 255);
	Serial.write((num >> 16) & 255);
	Serial.write((num >> 24) & 255);
}
//發送1位元組長的無號數
void sendUnsigned1ByteNumber(unsigned char num){
	Serial.write(num);
}
//發送2位元組長的無號數
void sendUnsigned2ByteNumber(unsigned int num){
	Serial.write(num & 255);
	Serial.write((num >> 8) & 255);
}
//發送4位元組長的無號數
void sendUnsigned4ByteNumber(unsigned long num){
	Serial.write(num & 255);
	Serial.write((num >> 8) & 255);
	Serial.write((num >> 16) & 255);
	Serial.write((num >> 24) & 255);
}

//接收1位元組長的有號數
char receive1ByteNumber(){
	while(Serial.available() < 1){}
	return Serial.read();
}
//接收2位元組長的有號數
int  receive2ByteNumber(){
	int num;
	while(Serial.available() < 2){}
	num=(int)Serial.read();
	num|=((int)Serial.read() << 8);
	return num;
}
//接收4位元組長的有號數
long receive4ByteNumber(){
	long num;
	while(Serial.available() < 4){}
	num=(long)Serial.read();
	num|=((long)Serial.read() << 8);
	num|=((long)Serial.read() << 16);
	num|=((long)Serial.read() << 24);
	return num;
}

//發送文字
void sendText(const String &str){
	Serial.print(str);
}
//接收文字
String receiveText(){
	return Serial.readString();
}
//接收指定長度的文字(長度為len)
String receiveText(int len){
	char data[len];
	while(Serial.available()<len){}
	Serial.readBytes(data, len);
	return String(data);
}