#include "Car.h"
#include "Line.h"
#include "Ultrasonic.h"
#include "Bluetooth.h"
void setup() {
  setupLine();
  setupUltrasonic();
  setupBluetooth();
}
/*
前進 => "f"(1Byte)+速度(2Byte)+時間(4Byte)
後退 => "b"(1Byte)+速度(2Byte)+時間(4Byte)
左轉 => "l"(1Byte)+速度(2Byte)+時間(4Byte)
右轉 => "r"(1Byte)+速度(2Byte)+時間(4Byte)
停止 => "s"(1Byte)+速度(2Byte)+時間(4Byte)

轉頭 => "a"(1Byte)+角度(2Byte)

測量 => "m"(1Byte)
     <= 左紅外線(1Byte)+中紅外線(1Byte)+右紅外線(1Byte)+超音波時間(4Byte)
*/
void loop() {
  //如果有收到資料
  if(bytesAvailableToReceive()>0){
    String cmd=receiveText(1);
    if(cmd=="f"){//前進
      
      //接收前進速度(2位元組長)
      int speed=receive2ByteNumber();
      
      //接收前進時間(4位元組長)
      long time=receive4ByteNumber();
      
      car_forward(speed,time);
    }else if(cmd=="b"){//後退
      
      //接收後退速度(2位元組長)
      int speed=receive2ByteNumber();
      
      //接收後退時間(4位元組長)
      long time=receive4ByteNumber();
      
      car_backward(speed,time);
    }else if(cmd=="l"){//左轉
      
      //接收左轉速度(2位元組長)
      int speed=receive2ByteNumber();
      
      //接收左轉時間(4位元組長)
      long time=receive4ByteNumber();
      
      car_left(speed,time);
    }else if(cmd=="r"){//右轉
      
      //接收右轉速度(2位元組長)
      int speed=receive2ByteNumber();
      
      //接收右轉時間(4位元組長)
      long time=receive4ByteNumber();
      
      car_right(speed,time);
    }else if(cmd=="s"){//停止
      
      //接收停止速度(2位元組長)
      int speed=receive2ByteNumber();
      
      //接收停止時間(4位元組長)
      long time=receive4ByteNumber();
      
      car_stop(speed,time);
    }else if(cmd=="a"){//轉動超音波感測器
      
      //接收要轉到的角度(2位元組長)
      int angle=receive2ByteNumber();
      
      rotateNeck(angle);
      
    }else if(cmd=="m"){//測量紅外線感測器與超音波感測器
      //測試左側
      if(line_left()){
        sendUnsigned1ByteNumber(1);
      }else{
        sendUnsigned1ByteNumber(0);
      }
      //測試中間
      if(line_middle()){
        sendUnsigned1ByteNumber(1);
      }else{
        sendUnsigned1ByteNumber(0);
      }
      //測試右側
      if(line_right()){
        sendUnsigned1ByteNumber(1);
      }else{
        sendUnsigned1ByteNumber(0);
      }
      //發送超音波來回的時間(微秒)(4位元組長)
      //*因為AppInventor的藍芽只能接收整數資料
      //*所以我們送整數時間過去再在AppInventor轉換
      long timing=getTiming();
      sendSigned4ByteNumber(timing);
    }    
  }
}

