#include "Car.h"
#include "Line.h"
#include "Ultrasonic.h"
#include "Bluetooth.h"

static bool is_auto_mode = false; //表示目前的狀態

void setup() {
  setupLine();
  setupUltrasonic();
  setupBluetooth();
}
/*
自動 => "s"(1Byte)

前進 => "f"(1Byte)
後退 => "b"(1Byte)
左轉 => "l"(1Byte)
右轉 => "r"(1Byte)
停止 => "s"(1Byte)
*/
void loop() {

  int state=0;           //設置state為0
  if(line_right()){      //如果右側感測到線
    state = state + 1;   //將state增加1
  }
  if(line_middle()){     //如果中間感測到線
    state = state + 2;   //將state增加2
  }
  if(line_left()){       //如果左側感測到線
    state = state + 4;   //將state增加4
  }
  
  if(bytesAvailableToReceive()>0){//如果有收到資料
    String cmd=receiveText(1);    //接收一個字元命令
    if(cmd=="c"){                 //如果命令是"c"=>切換模式
      
      if(is_auto_mode){          //    如果現在是自動模式
        is_auto_mode=false;      //    切換為非自動模式
      }else{                     //    否則
        is_auto_mode=true;       //    切換為自動模式
      }
      
    }else if(cmd=="f"){//前進
      car_forward(200,300);
    }else if(cmd=="b"){//後退
      car_backward(200,300);
    }else if(cmd=="l"){//左轉
      car_left(200,300);
    }else if(cmd=="r"){//右轉
      car_right(200,300);
    }else if(cmd=="s"){//停止
      car_stop(0,300);
    }
  }

  
  if(is_auto_mode){             //如果現在是自動模式
    if(toCM(getTiming())<15.0){
      //這裡填入遇到牆時，要做的動作
      
    }else if(state==0){
      //這裡填入左中右感測到是"白白白"時，要做的動作
      
    }else if(state==1){
      //這裡填入左中右感測到是"白白黑"時，要做的動作
      
    }else if(state==2){
      //這裡填入左中右感測到是"白黑白"時，要做的動作
      car_forward(200,100);  //車子前進100毫秒
    }else if(state==3){
      //這裡填入左中右感測到是"白黑黑"時，要做的動作
      
    }else if(state==4){
      //這裡填入左中右感測到是"黑白白"時，要做的動作
      
    }else if(state==5){
      //這裡填入左中右感測到是"黑白黑"時，要做的動作
      
    }else if(state==6){
      //這裡填入左中右感測到是"黑黑白"時，要做的動作
      
    }else if(state==7){
      //這裡填入左中右感測到是"黑黑黑"時，要做的動作
      
    }
  }
}

